Go to the latest version of this document.

# ``twisted`.`trial`.`reporter`.`TestResult``

class documentation

`class TestResult(pyunit.TestResult): (source)`

Known subclasses: `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.Reporter`

Implements interfaces: `twisted.trial.itrial.IReporter`

View In Hierarchy

Accumulates the results of several `twisted.trial.unittest.TestCase`s.

Method | `__init__` | Undocumented
Method | `__repr__` | Undocumented
Method | `addError` | Report an error that occurred while running the given test.
Method | `addExpectedFailure` | Report that the given test failed, and was expected to do so.
Method | `addFailure` | Report a failed assertion for the given test.
Method | `addSkip` | Report that the given test was skipped.
Method | `addSuccess` | Report that the given test succeeded.
Method | `addUnexpectedSuccess` | Report that the given test succeeded against expectations.
Method | `done` | The test suite has finished running.
Method | `startTest` | This must be called before the given test is commenced.
Method | `stopTest` | This must be called after the given test is completed.
Method | `wasSuccessful` | Report whether or not this test suite was successful or not.
Class Variable | `__test__` | Undocumented
Class Variable | `errors` | Undocumented
Instance Variable | `expectedFailures` | Undocumented
Instance Variable | `skips` | Undocumented
Instance Variable | `successes` | count the number of successes achieved by the test run.
Instance Variable | `unexpectedSuccesses` | Undocumented
Method | `_getFailure` | Convert a `sys.exc_info()`-style tuple to a `Failure`, if necessary.
Method | `_getTime` | Undocumented
Constant | `_DEFAULT_TODO` | Undocumented
Instance Variable | `_lastTime` | The duration of the current test run. It defaults to `None`, which means that the test was skipped.
Instance Variable | `_startTime` | The time when the current test was started. It defaults to `None`, which means that the test was skipped.
Instance Variable | `_testStarted` | Undocumented
Instance Variable | `_timings` | Undocumented

def __init__(self): (source)
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.Reporter`

Undocumented

def __repr__(self) -> `str`: (source)

Undocumented

def addError(self, test: `pyunit.TestCase`, error: `Failure | tuple[type[BaseException], BaseException, TracebackType] | tuple[None, None, None]`): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.Reporter`

Report an error that occurred while running the given test.

Parameters
test:`pyunit.TestCase` | Undocumented
error:`Failure` or `tuple` | Undocumented

def addExpectedFailure(self, test, error, todo=None): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.TextReporter`, `twisted.trial.reporter.TreeReporter`, `twisted.trial.reporter.VerboseTextReporter`

Report that the given test failed, and was expected to do so.

In Trial, tests can be marked 'todo'. That is, they are expected to fail.

Parameters
test:`pyunit.TestCase` | Undocumented
error:`Failure` | Undocumented
todo:`unittest.Todo`, or `None`, in which case a default todo message is provided. | Undocumented

def addFailure(self, test, fail): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.Reporter`

Report a failed assertion for the given test.

Parameters
test:`pyunit.TestCase` | Undocumented
fail:`Failure` or `tuple` | Undocumented

def addSkip(self, test, reason): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.TextReporter`, `twisted.trial.reporter.TreeReporter`, `twisted.trial.reporter.VerboseTextReporter`

Report that the given test was skipped.

In Trial, tests can be 'skipped'. Tests are skipped mostly because there is some platform or configuration issue that prevents them from being run correctly.

Parameters
test:`pyunit.TestCase` | Undocumented
reason:`str` | Undocumented

def addSuccess(self, test): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.TextReporter`, `twisted.trial.reporter.TreeReporter`, `twisted.trial.reporter.VerboseTextReporter`

Report that the given test succeeded.

Parameters
test:`pyunit.TestCase` | Undocumented

def addUnexpectedSuccess(self, test, todo=None): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`, `twisted.trial.reporter.TextReporter`, `twisted.trial.reporter.TreeReporter`, `twisted.trial.reporter.VerboseTextReporter`

Report that the given test succeeded against expectations.

In Trial, tests can be marked 'todo'. That is, they are expected to fail. When a test that is expected to fail instead succeeds, it should call this method to report the unexpected success.

Parameters
test:`pyunit.TestCase` | Undocumented
todo:`unittest.Todo`, or `None`, in which case a default todo message is provided. | Undocumented

def done(self): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial.reporter.Reporter`

The test suite has finished running.

def startTest(self, test): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial.reporter.Reporter`

This must be called before the given test is commenced.

Parameters
test:`pyunit.TestCase` | Undocumented

def stopTest(self, test): (source)
from `twisted.trial.itrial.IReporter`
overridden in `twisted.trial.reporter.VerboseTextReporter`

This must be called after the given test is completed.

Parameters
test:`pyunit.TestCase` | Undocumented

def wasSuccessful(self): (source)
from `twisted.trial.itrial.IReporter`

Report whether or not this test suite was successful or not.

The behaviour of this method changed in `pyunit` in Python 3.4 to fail if there are any errors, failures, or unexpected successes. Previous to 3.4, it was only if there were errors or failures. This method implements the old behaviour for backwards compatibility reasons, checking just for errors and failures.

Returns
`bool` | Undocumented

__test__: `bool` = (source)

Undocumented

errors: `list[tuple[itrial.ITestCase | pyunit.TestCase, str | Failure]]` = (source)

Undocumented

expectedFailures: `list[tuple[itrial.ITestCase, str | Failure, Todo]]` = (source)

Undocumented

skips: `list[tuple[itrial.ITestCase, str]]` = (source)

Undocumented

successes: `int` = (source)

count the number of successes achieved by the test run.

unexpectedSuccesses: `list[tuple[itrial.ITestCase, str]]` = (source)

Undocumented

def _getFailure(self, error): (source)
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`

Convert a `sys.exc_info()`-style tuple to a `Failure`, if necessary.

def _getTime(self): (source)

Undocumented

_DEFAULT_TODO: `str` = (source)
overridden in `twisted.trial._dist.workerreporter.WorkerReporter`

Undocumented

Value

    'Test expected to fail'

_lastTime: `int | None` = (source)

The duration of the current test run. It defaults to `None`, which means that the test was skipped.

_startTime = (source)
overridden in `twisted.trial.reporter.Reporter`

The time when the current test was started. It defaults to `None`, which means that the test was skipped.

_testStarted: `int | None` = (source)

Undocumented

_timings: `list` = (source)

Undocumented